VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3510
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4170
   LinkTopic       =   "Form1"
   ScaleHeight     =   3510
   ScaleWidth      =   4170
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtYear 
      Height          =   285
      Left            =   840
      TabIndex        =   10
      Top             =   3120
      Width           =   615
   End
   Begin VB.TextBox txtPages 
      Height          =   285
      Left            =   840
      TabIndex        =   8
      Top             =   2760
      Width           =   615
   End
   Begin VB.TextBox txtPicture 
      Height          =   285
      Left            =   840
      TabIndex        =   6
      Top             =   2400
      Width           =   3255
   End
   Begin VB.TextBox txtURL 
      Height          =   285
      Left            =   840
      TabIndex        =   4
      Top             =   2040
      Width           =   3255
   End
   Begin VB.TextBox txtISBN 
      Height          =   285
      Left            =   840
      TabIndex        =   2
      Top             =   1680
      Width           =   3255
   End
   Begin VB.ListBox lstTitles 
      Height          =   1425
      Left            =   120
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   120
      Width           =   3975
   End
   Begin VB.Label Label1 
      Caption         =   "Year"
      Height          =   255
      Index           =   4
      Left            =   120
      TabIndex        =   9
      Top             =   3120
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Pages"
      Height          =   255
      Index           =   3
      Left            =   120
      TabIndex        =   7
      Top             =   2760
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Picture"
      Height          =   255
      Index           =   2
      Left            =   120
      TabIndex        =   5
      Top             =   2400
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "URL"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   3
      Top             =   2040
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "ISBN"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   1680
      Width           =   615
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type BookType
    Title As String * 50
    URL As String * 50
    ISBN As String * 13
    Picture As String * 50
    Pages As String * 4
    Year As String * 4
End Type

Private m_NumBookData As Integer
Private m_BookData() As BookType

Private m_SelectedRecord As Integer
' Load the newly selected record's data.
Private Sub LoadRecordFromArray()
    m_SelectedRecord = lstTitles.ItemData(lstTitles.ListIndex)

    With m_BookData(m_SelectedRecord)
        txtURL.Text = Trim$(.URL)
        txtISBN.Text = Trim$(.ISBN)
        txtPicture.Text = Trim$(.Picture)
        txtPages.Text = Trim$(.Pages)
        txtYear.Text = Trim$(.Year)
    End With
End Sub
' Update the previously selected record.
Private Sub SaveRecordToArray()
    ' Do nothing if no record is currently selected.
    If m_SelectedRecord < 0 Then Exit Sub

    ' Save the data.
    With m_BookData(m_SelectedRecord)
        .URL = txtURL.Text
        .ISBN = txtISBN.Text
        .Picture = txtPicture.Text
        .Year = txtYear.Text
        .Pages = txtPages.Text
    End With
End Sub
Private Sub Form_Load()
Dim buffer As BookType
Dim file_length As Long
Dim file_name As String
Dim fnum As Integer
Dim i As Integer

    ' Get the file name.
    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "Books.dat"

    ' Get the file's size and allocate room.
    file_length = FileLen(file_name)
    m_NumBookData = file_length / Len(buffer)
    ReDim m_BookData(0 To m_NumBookData - 1)

    ' Load the book information.
    fnum = FreeFile
    Open file_name For Binary As fnum Len = file_length
    Get #fnum, 1, m_BookData
    Close fnum

    ' List the titles.
    For i = 0 To m_NumBookData - 1
        lstTitles.AddItem m_BookData(i).Title
        ' Save the index in the data array.
        lstTitles.ItemData(lstTitles.NewIndex) = i
    Next i

    ' Display the first record.
    m_SelectedRecord = -1
    lstTitles.ListIndex = 0
End Sub
Private Sub Form_Unload(Cancel As Integer)
Dim file_name As String
Dim fnum As Integer
Dim buffer As BookType
Dim record_number As Integer

    ' Save the current record's data to the array
    ' in case the user just made changes.
    SaveRecordToArray

    ' Get the file name.
    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "Books.dat"

    ' Open the file.
    fnum = FreeFile
    Open file_name For Binary As fnum Len = m_NumBookData * Len(buffer)

    ' Write out the array.
    Put #fnum, 1, m_BookData
    Close #fnum
End Sub
' Display this item's data.
Private Sub lstTitles_Click()
    ' Save the currently entered data.
    SaveRecordToArray

    ' Load the newly selected record's data.
    LoadRecordFromArray
End Sub
